#ifndef AVIFILE_SUNAUDIORENDERER_H
#define AVIFILE_SUNAUDIORENDERER_H

#include "IAudioRenderer.h"

#ifdef SUNAUDIO_SUPPORT

class SunAudioRenderer: public IAudioRenderer
{
public:
//  void doAudioExtract(double);
    SunAudioRenderer(IAviReadStream* stream, WAVEFORMATEX& Owf, const char* cname = 0);
    ~SunAudioRenderer();
				//restart thread if it waits
protected:
    virtual double getRendererBufferTime() const;

    virtual void reset();
    virtual void pause(int state);
    virtual void setVolume(float volume);
    static void* doAudioOut(void* arg);

    int m_iAudioFd;		// /dev/audio file descriptor

    uint_t m_iSamplesSent;	// number of samples written to device
    PthreadTask* m_AudioThread;	// Writes data to audio_fd
};

#endif // SUNAUDIO_SUPPORT
#endif // AVIFILE_SUNAUDIORENDERER_H
