#ifndef MEMQUEUE
#define MEMQUEUE

#include "default.h"
#include "Locker.h"

#include <sys/types.h>


class MemQueue
{
    PthreadMutex m_Mutex;
    uint8_t* buffer;
    int alloc;          // size of allocated buffer

    int outpos;         // current output position
    int inpos;          // current input position
    uint_t length;         // actual size of valid data in queue
    uint_t maxpos;         // limit for output position
    int lastpos;        // last written byte
    //int lastposcpy;
    uint_t maxfragment;
public:
    MemQueue(uint_t bufsize, uint_t maxfrag);
    ~MemQueue();
    void Add(uint_t);
    uint8_t* GetFree(uint_t);
    uint8_t* GetData(uint_t);
    void Free(uint_t);

    void DebugPrint();
};

#endif // MEMQUEUE_H
